# HG changeset patch
# Node ID 3b0d15826668
# Parent  445f5cc52e1a
diff --git a/ChangeLog.API b/ChangeLog.API
--- a/ChangeLog.API
+++ b/ChangeLog.API
@@ -320,7 +320,9 @@
 		* PurpleAccountPrefsUiOps
 		* purple_account_add_buddies_with_invite
 		* purple_account_add_buddy_with_invite
+		* purple_account_destroy_log
 		* purple_account_get_check_mail
+		* purple_account_get_log
 		* purple_account_get_password.  Use
 		  purple_credential_manager_read_password_async instead.
 		* purple_account_get_public_alias
@@ -367,8 +369,10 @@
 		* purple_conv_custom_smiley_write
 		* PurpleConversationType
 		* purple_conversation_add_smiley
+		* purple_conversation_close_logs
 		* purple_conversation_get_remote_smileys
 		* purple_conversation_get_smiley
+		* purple_conversation_is_logging
 		* purple_conversations_add. Use purple_conversation_manager_register
 		  instead.
 		* purple_conversations_remove. Use
@@ -383,6 +387,7 @@
 		  purple_conversation_manager_find_chat instead.
 		* purple_conversations_find_chat. Use
 		  purple_conversation_manager_find_chat_by_id instead.
+		* purple_conversation_set_logging
 		* purple_core_ensure_single_instance. Check via GApplication
 		  or whatever is appropriate for your UI.
 		* purple_core_migrate
diff --git a/finch/gntblist.c b/finch/gntblist.c
--- a/finch/gntblist.c
+++ b/finch/gntblist.c
@@ -131,7 +131,6 @@
 static int blist_node_compare_position(PurpleBlistNode *n1, PurpleBlistNode *n2);
 static int blist_node_compare_text(PurpleBlistNode *n1, PurpleBlistNode *n2);
 static int blist_node_compare_status(PurpleBlistNode *n1, PurpleBlistNode *n2);
-static int blist_node_compare_log(PurpleBlistNode *n1, PurpleBlistNode *n2);
 
 static int color_available;
 static int color_away;
@@ -1843,9 +1842,6 @@
 	} else if (purple_strequal(purple_prefs_get_string(PREF_ROOT "/sort_type"), "status")) {
 		gnt_tree_set_compare_func(GNT_TREE(ggblist->tree),
 			(GCompareFunc)blist_node_compare_status);
-	} else if (purple_strequal(purple_prefs_get_string(PREF_ROOT "/sort_type"), "log")) {
-		gnt_tree_set_compare_func(GNT_TREE(ggblist->tree),
-			(GCompareFunc)blist_node_compare_log);
 	}
 
 	list = purple_blist_get_default();
@@ -2228,49 +2224,6 @@
 	return ret;
 }
 
-static int
-get_contact_log_size(PurpleBlistNode *c)
-{
-	int log = 0;
-	PurpleBlistNode *node;
-
-	for (node = purple_blist_node_get_first_child(c); node; node = purple_blist_node_get_sibling_next(node)) {
-		PurpleBuddy *b = (PurpleBuddy*)node;
-		log += purple_log_get_total_size(PURPLE_LOG_IM, purple_buddy_get_name(b),
-				purple_buddy_get_account(b));
-	}
-
-	return log;
-}
-
-static int
-blist_node_compare_log(PurpleBlistNode *n1, PurpleBlistNode *n2)
-{
-	int ret;
-	PurpleBuddy *b1, *b2;
-
-	if (G_OBJECT_TYPE(n1) != G_OBJECT_TYPE(n2))
-		return blist_node_compare_position(n1, n2);
-
-	if (PURPLE_IS_BUDDY(n1)) {
-		b1 = (PurpleBuddy*)n1;
-		b2 = (PurpleBuddy*)n2;
-		ret = purple_log_get_total_size(PURPLE_LOG_IM, purple_buddy_get_name(b2), purple_buddy_get_account(b2)) -
-				purple_log_get_total_size(PURPLE_LOG_IM, purple_buddy_get_name(b1), purple_buddy_get_account(b1));
-		if (ret != 0)
-			return ret;
-	} else if (PURPLE_IS_CONTACT(n1)) {
-		ret = get_contact_log_size(n2) - get_contact_log_size(n1);
-		if (ret != 0)
-			return ret;
-	} else {
-		return blist_node_compare_position(n1, n2);
-	}
-
-	ret = blist_node_compare_text(n1, n2);
-	return ret;
-}
-
 static void
 plugin_action(GntMenuItem *item, gpointer data)
 {
diff --git a/finch/gntconv.c b/finch/gntconv.c
--- a/finch/gntconv.c
+++ b/finch/gntconv.c
@@ -490,42 +490,6 @@
 }
 
 static void
-toggle_logging_cb(GntMenuItem *item, gpointer ggconv)
-{
-	FinchConv *fc = ggconv;
-	PurpleConversation *conv = fc->active_conv;
-	gboolean logging = gnt_menuitem_check_get_checked(GNT_MENU_ITEM_CHECK(item));
-	GList *iter;
-
-	if (logging == purple_conversation_is_logging(conv))
-		return;
-
-	/* Xerox */
-	if (logging) {
-		/* Enable logging first so the message below can be logged. */
-		purple_conversation_set_logging(conv, TRUE);
-
-		purple_conversation_write_system_message(conv,
-			_("Logging started. Future messages in this "
-			"conversation will be logged."), 0);
-	} else {
-		purple_conversation_write_system_message(conv,
-			_("Logging stopped. Future messages in this "
-			"conversation will not be logged."), 0);
-
-		/* Disable the logging second, so that the above message can be logged. */
-		purple_conversation_set_logging(conv, FALSE);
-	}
-
-	/* Each conversation with the same person will have the same logging setting */
-	for (iter = fc->list; iter; iter = iter->next) {
-		if (iter->data == conv)
-			continue;
-		purple_conversation_set_logging(iter->data, logging);
-	}
-}
-
-static void
 send_to_cb(GntMenuItem *m, gpointer n)
 {
 	PurpleAccount *account = g_object_get_data(G_OBJECT(m), "purple_account");
@@ -654,12 +618,6 @@
 		gnt_menuitem_set_callback(item, invite_cb, ggc);
 	}
 
-	item = gnt_menuitem_check_new(_("Enable Logging"));
-	gnt_menuitem_check_set_checked(GNT_MENU_ITEM_CHECK(item),
-			purple_conversation_is_logging(ggc->active_conv));
-	gnt_menu_add_item(GNT_MENU(sub), item);
-	gnt_menuitem_set_callback(item, toggle_logging_cb, ggc);
-
 	item = gnt_menuitem_new(_("Plugins"));
 	gnt_menu_add_item(GNT_MENU(menu), item);
 	ggc->plugins = item;
@@ -768,12 +726,6 @@
 	else
 		ggc = g_new0(FinchConv, 1);
 
-	/* Each conversation with the same person will have the same logging setting */
-	if (ggc->list) {
-		purple_conversation_set_logging(conv,
-				purple_conversation_is_logging(ggc->list->data));
-	}
-
 	ggc->list = g_list_prepend(ggc->list, conv);
 	ggc->active_conv = conv;
 	g_object_set_data(G_OBJECT(conv), "finch", ggc);
diff --git a/finch/gntprefs.c b/finch/gntprefs.c
--- a/finch/gntprefs.c
+++ b/finch/gntprefs.c
@@ -68,12 +68,6 @@
 } Prefs;
 
 static GList *
-get_log_options(void)
-{
-	return purple_log_logger_get_options();
-}
-
-static GList *
 get_idle_options(void)
 {
 	GList *list = NULL;
@@ -185,7 +179,6 @@
 
 static Prefs logging[] =
 {
-	{PURPLE_PREF_STRING, "/purple/logging/format", N_("Log format"), get_log_options},
 	{PURPLE_PREF_BOOLEAN, "/purple/logging/log_ims", N_("Log IMs"), NULL},
 	{PURPLE_PREF_BOOLEAN, "/purple/logging/log_chats", N_("Log chats"), NULL},
 	{PURPLE_PREF_BOOLEAN, "/purple/logging/log_system", N_("Log status change events"), NULL},
diff --git a/finch/plugins/meson.build b/finch/plugins/meson.build
--- a/finch/plugins/meson.build
+++ b/finch/plugins/meson.build
@@ -16,12 +16,6 @@
 	    install : true, install_dir : FINCH_PLUGINDIR)
 endif
 
-gnthistory = library('gnthistory', 'gnthistory.c',
-    c_args : ['-DG_LOG_USE_STRUCTURED', '-DG_LOG_DOMAIN="Gnt-History"'],
-    dependencies : [libpurple_dep, libfinch_dep, glib],
-    name_prefix : '',
-    install : true, install_dir : FINCH_PLUGINDIR)
-
 gntlastlog = library('gntlastlog', 'lastlog.c',
     c_args : ['-DG_LOG_USE_STRUCTURED', '-DG_LOG_DOMAIN="Gnt-LastLog"'],
     dependencies : [libpurple_dep, libfinch_dep, ncurses, glib],
diff --git a/libpurple/account.h b/libpurple/account.h
--- a/libpurple/account.h
+++ b/libpurple/account.h
@@ -56,7 +56,7 @@
 
 #include "buddy.h"
 #include "connection.h"
-#include "log.h"
+#include "group.h"
 #include "proxy.h"
 #include "protocol.h"
 #include "status.h"
@@ -1041,31 +1041,6 @@
 gboolean purple_account_get_ui_bool(PurpleAccount *account, const char *ui,
 								  const char *name, gboolean default_value);
 
-
-/**
- * purple_account_get_log:
- * @account: The account.
- * @create:  Should it be created if it doesn't exist?
- *
- * Returns the system log for an account.
- *
- * Note: Callers should almost always pass %FALSE for @a create.
- *       Passing %TRUE could result in an existing log being reopened,
- *       if the log has already been closed, which not all loggers deal
- *       with appropriately.
- *
- * Returns: The log.
- */
-PurpleLog *purple_account_get_log(PurpleAccount *account, gboolean create);
-
-/**
- * purple_account_destroy_log:
- * @account: The account.
- *
- * Frees the system log of an account
- */
-void purple_account_destroy_log(PurpleAccount *account);
-
 /**
  * purple_account_add_buddy:
  * @account: The account.
diff --git a/libpurple/account.c b/libpurple/account.c
--- a/libpurple/account.c
+++ b/libpurple/account.c
@@ -92,7 +92,6 @@
 	GList *status_types;        /* Status types.                          */
 
 	PurplePresence *presence;     /* Presence.                            */
-	PurpleLog *system_log;        /* The system log                       */
 
 	PurpleAccountRegistrationCb registration_cb;
 	void *registration_cb_user_data;
@@ -976,7 +975,6 @@
 			g_free, delete_setting);
 	priv->ui_settings = g_hash_table_new_full(g_str_hash, g_str_equal,
 			g_free, (GDestroyNotify)g_hash_table_destroy);
-	priv->system_log = NULL;
 
 	priv->privacy_type = PURPLE_ACCOUNT_PRIVACY_ALLOW_ALL;
 }
@@ -1075,9 +1073,6 @@
 	if (priv->proxy_info)
 		purple_proxy_info_destroy(priv->proxy_info);
 
-	if(priv->system_log)
-		purple_log_free(priv->system_log);
-
 	if (priv->current_error) {
 		g_free(priv->current_error->description);
 		g_free(priv->current_error);
@@ -2730,52 +2725,6 @@
 	return g_value_get_boolean(&setting->value);
 }
 
-PurpleLog *
-purple_account_get_log(PurpleAccount *account, gboolean create)
-{
-	PurpleAccountPrivate *priv;
-
-	g_return_val_if_fail(PURPLE_IS_ACCOUNT(account), NULL);
-
-	priv = purple_account_get_instance_private(account);
-
-	if(!priv->system_log && create){
-		PurplePresence *presence;
-		int login_time;
-		GDateTime *dt;
-
-		presence = purple_account_get_presence(account);
-		login_time = purple_presence_get_login_time(presence);
-		if (login_time != 0) {
-			dt = g_date_time_new_from_unix_local(login_time);
-		} else {
-			dt = g_date_time_new_now_local();
-		}
-
-		priv->system_log = purple_log_new(PURPLE_LOG_SYSTEM,
-		                                  purple_account_get_username(account),
-		                                  account, NULL, dt);
-		g_date_time_unref(dt);
-	}
-
-	return priv->system_log;
-}
-
-void
-purple_account_destroy_log(PurpleAccount *account)
-{
-	PurpleAccountPrivate *priv;
-
-	g_return_if_fail(PURPLE_IS_ACCOUNT(account));
-
-	priv = purple_account_get_instance_private(account);
-
-	if(priv->system_log){
-		purple_log_free(priv->system_log);
-		priv->system_log = NULL;
-	}
-}
-
 void
 purple_account_add_buddy(PurpleAccount *account, PurpleBuddy *buddy, const char *message)
 {
diff --git a/libpurple/buddyicon.h b/libpurple/buddyicon.h
--- a/libpurple/buddyicon.h
+++ b/libpurple/buddyicon.h
@@ -53,6 +53,7 @@
 typedef struct _PurpleBuddyIconSpec PurpleBuddyIconSpec;
 
 #include "account.h"
+#include "blistnode.h"
 #include "buddylist.h"
 #include "image.h"
 #include "protocols.h"
diff --git a/libpurple/buddylist.c b/libpurple/buddylist.c
--- a/libpurple/buddylist.c
+++ b/libpurple/buddylist.c
@@ -24,6 +24,7 @@
 #include <glib/gi18n-lib.h>
 
 #include "internal.h"
+#include "account.h"
 #include "buddylist.h"
 #include "debug.h"
 #include "notify.h"
diff --git a/libpurple/connection.c b/libpurple/connection.c
--- a/libpurple/connection.c
+++ b/libpurple/connection.c
@@ -27,7 +27,6 @@
 #include "buddylist.h"
 #include "connection.h"
 #include "debug.h"
-#include "log.h"
 #include "notify.h"
 #include "prefs.h"
 #include "proxy.h"
@@ -201,23 +200,6 @@
 		/* Set the time the account came online */
 		purple_presence_set_login_time(presence, time(NULL));
 
-		if (purple_prefs_get_bool("/purple/logging/log_system"))
-		{
-			PurpleLog *log = purple_account_get_log(account, TRUE);
-
-			if (log != NULL)
-			{
-				char *msg = g_strdup_printf(_("+++ %s signed on"),
-											purple_account_get_username(account));
-				GDateTime *dt = g_date_time_new_from_unix_local(purple_presence_get_login_time(presence));
-				purple_log_write(log, PURPLE_MESSAGE_SYSTEM,
-				                 purple_account_get_username(account),
-				                 dt, msg);
-				g_date_time_unref(dt);
-				g_free(msg);
-			}
-		}
-
 		if (ops != NULL && ops->connected != NULL)
 			ops->connected(gc);
 
@@ -244,27 +226,6 @@
 		}
 	}
 	else if (priv->state == PURPLE_CONNECTION_DISCONNECTED) {
-		PurpleAccount *account = purple_connection_get_account(gc);
-
-		if (purple_prefs_get_bool("/purple/logging/log_system"))
-		{
-			PurpleLog *log = purple_account_get_log(account, FALSE);
-
-			if (log != NULL)
-			{
-				char *msg = g_strdup_printf(_("+++ %s signed off"),
-											purple_account_get_username(account));
-				GDateTime *dt = g_date_time_new_now_utc();
-				purple_log_write(log, PURPLE_MESSAGE_SYSTEM,
-				                 purple_account_get_username(account),
-				                 dt, msg);
-				g_date_time_unref(dt);
-				g_free(msg);
-			}
-		}
-
-		purple_account_destroy_log(account);
-
 		if (ops != NULL && ops->disconnected != NULL)
 			ops->disconnected(gc);
 	}
diff --git a/libpurple/conversations.c b/libpurple/conversations.c
--- a/libpurple/conversations.c
+++ b/libpurple/conversations.c
@@ -20,6 +20,8 @@
  * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111-1301  USA
  */
 #include "internal.h"
+
+#include "conversations.h"
 #include "purpleprivate.h"
 
 #include "purpleconversationmanager.h"
diff --git a/libpurple/core.c b/libpurple/core.c
--- a/libpurple/core.c
+++ b/libpurple/core.c
@@ -24,6 +24,7 @@
 #include "internal.h"
 #include "cmds.h"
 #include "connection.h"
+#include "conversations.h"
 #include "core.h"
 #include "debug.h"
 #include "xfer.h"
@@ -169,7 +170,6 @@
 	purple_conversation_manager_startup();
 	purple_whiteboard_manager_startup();
 	purple_blist_init();
-	purple_log_init();
 	purple_history_manager_startup();
 	purple_network_init();
 	purple_proxy_init();
@@ -249,7 +249,6 @@
 
 	purple_history_manager_shutdown();
 
-	purple_log_uninit();
 	/* Everything after util_uninit cannot try to write things to the
 	 * confdir.
 	 */
@@ -365,7 +364,6 @@
 	xdg_dir_exists = g_file_test(purple_data_dir(), G_FILE_TEST_EXISTS);
 	if (!xdg_dir_exists) {
 		MIGRATE_TO_XDG_DIR(purple_data_dir(), "certificates");
-		MIGRATE_TO_XDG_DIR(purple_data_dir(), "logs");
 		MIGRATE_TO_XDG_DIR(purple_config_dir(), "accounts.xml");
 		MIGRATE_TO_XDG_DIR(purple_config_dir(), "blist.xml");
 		MIGRATE_TO_XDG_DIR(purple_config_dir(), "fs-codec.conf");
diff --git a/libpurple/idle.c b/libpurple/idle.c
--- a/libpurple/idle.c
+++ b/libpurple/idle.c
@@ -22,10 +22,10 @@
  */
 
 #include "connection.h"
+#include "conversations.h"
 #include "debug.h"
 #include "eventloop.h"
 #include "idle.h"
-#include "log.h"
 #include "prefs.h"
 #include "savedstatuses.h"
 #include "signals.h"
diff --git a/libpurple/meson.build b/libpurple/meson.build
--- a/libpurple/meson.build
+++ b/libpurple/meson.build
@@ -20,7 +20,6 @@
 	'idle.c',
 	'image.c',
 	'image-store.c',
-	'log.c',
 	'media/backend-fs2.c',
 	'media/backend-iface.c',
 	'media/candidate.c',
@@ -120,7 +119,6 @@
 	'idle.h',
 	'image.h',
 	'image-store.h',
-	'log.h',
 	'media.h',
 	'mediamanager.h',
 	'memorypool.h',
diff --git a/libpurple/protocol.c b/libpurple/protocol.c
--- a/libpurple/protocol.c
+++ b/libpurple/protocol.c
@@ -22,6 +22,7 @@
 
 #include "protocol.h"
 
+#include "accounts.h"
 #include "purpleenums.h"
 
 enum {
diff --git a/libpurple/protocols.c b/libpurple/protocols.c
--- a/libpurple/protocols.c
+++ b/libpurple/protocols.c
@@ -37,6 +37,7 @@
 #include "purpleprotocolmedia.h"
 #include "purpleprotocolserver.h"
 #include "request.h"
+#include "server.h"
 #include "util.h"
 
 /**************************************************************************
diff --git a/libpurple/purpleaccountpresence.c b/libpurple/purpleaccountpresence.c
--- a/libpurple/purpleaccountpresence.c
+++ b/libpurple/purpleaccountpresence.c
@@ -64,32 +64,6 @@
 	time_t idle_time = purple_presence_get_idle_time(presence);
 	time_t current_time = time(NULL);
 
-	if(purple_prefs_get_bool("/purple/logging/log_system")) {
-		PurpleLog *log = purple_account_get_log(account_presence->account,
-		                                        FALSE);
-
-		if(log != NULL) {
-			gchar *msg, *tmp;
-			GDateTime *dt;
-
-			if(idle) {
-				tmp = g_strdup_printf(_("+++ %s became idle"), purple_account_get_username(account_presence->account));
-				dt = g_date_time_new_from_unix_local(idle_time);
-			} else {
-				tmp = g_strdup_printf(_("+++ %s became unidle"), purple_account_get_username(account_presence->account));
-				dt = g_date_time_new_now_utc();
-			}
-
-			msg = g_markup_escape_text(tmp, -1);
-			g_free(tmp);
-			purple_log_write(log, PURPLE_MESSAGE_SYSTEM,
-			                 purple_account_get_username(account_presence->account),
-			                 dt, msg);
-			g_date_time_unref(dt);
-			g_free(msg);
-		}
-	}
-
 	gc = purple_account_get_connection(account_presence->account);
 
 	if(PURPLE_CONNECTION_IS_CONNECTED(gc)) {
diff --git a/libpurple/purplebuddypresence.c b/libpurple/purplebuddypresence.c
--- a/libpurple/purplebuddypresence.c
+++ b/libpurple/purplebuddypresence.c
@@ -135,52 +135,8 @@
 {
 	PurpleBuddy *buddy = purple_buddy_presence_get_buddy(PURPLE_BUDDY_PRESENCE(presence));
 	GDateTime *current_time = g_date_time_new_now_utc();
-	PurpleAccount *account = purple_buddy_get_account(buddy);
 	gboolean idle = purple_presence_is_idle(presence);
 
-	if (!old_idle && idle)
-	{
-		if (purple_prefs_get_bool("/purple/logging/log_system"))
-		{
-			PurpleLog *log = purple_account_get_log(account, FALSE);
-
-			if (log != NULL)
-			{
-				char *tmp, *tmp2;
-				tmp = g_strdup_printf(_("%s became idle"),
-				purple_buddy_get_alias(buddy));
-				tmp2 = g_markup_escape_text(tmp, -1);
-				g_free(tmp);
-
-				purple_log_write(log, PURPLE_MESSAGE_SYSTEM,
-				                 purple_buddy_get_alias(buddy),
-				                 current_time, tmp2);
-				g_free(tmp2);
-			}
-		}
-	}
-	else if (old_idle && !idle)
-	{
-		if (purple_prefs_get_bool("/purple/logging/log_system"))
-		{
-			PurpleLog *log = purple_account_get_log(account, FALSE);
-
-			if (log != NULL)
-			{
-				char *tmp, *tmp2;
-				tmp = g_strdup_printf(_("%s became unidle"),
-				purple_buddy_get_alias(buddy));
-				tmp2 = g_markup_escape_text(tmp, -1);
-				g_free(tmp);
-
-				purple_log_write(log, PURPLE_MESSAGE_SYSTEM,
-				                 purple_buddy_get_alias(buddy),
-				                 current_time, tmp2);
-				g_free(tmp2);
-			}
-		}
-	}
-
 	if (old_idle != idle)
 		purple_signal_emit(purple_blist_get_handle(), "buddy-idle-changed", buddy,
 		                 old_idle, idle);
diff --git a/libpurple/purplechatconversation.c b/libpurple/purplechatconversation.c
--- a/libpurple/purplechatconversation.c
+++ b/libpurple/purplechatconversation.c
@@ -28,6 +28,7 @@
 #include "purplechatconversation.h"
 #include "purpleenums.h"
 #include "purpleprivate.h"
+#include "server.h"
 
 typedef struct {
 	GList *ignored;     /* Ignored users.                            */
@@ -203,10 +204,6 @@
 		purple_chat_conversation_set_nick(chat, username);
 	}
 
-	if(purple_prefs_get_bool("/purple/logging/log_chats")) {
-		purple_conversation_set_logging(PURPLE_CONVERSATION(chat), TRUE);
-	}
-
 	g_object_unref(account);
 }
 
diff --git a/libpurple/purplechatuser.c b/libpurple/purplechatuser.c
--- a/libpurple/purplechatuser.c
+++ b/libpurple/purplechatuser.c
@@ -21,6 +21,8 @@
  */
 
 #include "purplechatuser.h"
+
+#include "conversations.h"
 #include "purpleenums.h"
 
 struct _PurpleChatUser {
diff --git a/libpurple/purpleconversation.h b/libpurple/purpleconversation.h
--- a/libpurple/purpleconversation.h
+++ b/libpurple/purpleconversation.h
@@ -139,7 +139,6 @@
 #include <purpleconversationuiops.h>
 #include "account.h"
 #include "buddyicon.h"
-#include "log.h"
 
 G_BEGIN_DECLS
 
@@ -263,37 +262,6 @@
 const char *purple_conversation_get_name(PurpleConversation *conv);
 
 /**
- * purple_conversation_set_logging:
- * @conv: The conversation.
- * @log:  %TRUE if logging should be enabled, or %FALSE otherwise.
- *
- * Enables or disables logging for this conversation.
- */
-void purple_conversation_set_logging(PurpleConversation *conv, gboolean log);
-
-/**
- * purple_conversation_is_logging:
- * @conv: The conversation.
- *
- * Returns whether or not logging is enabled for this conversation.
- *
- * Returns: %TRUE if logging is enabled, or %FALSE otherwise.
- */
-gboolean purple_conversation_is_logging(PurpleConversation *conv);
-
-/**
- * purple_conversation_close_logs:
- * @conv: The conversation.
- *
- * Closes any open logs for this conversation.
- *
- * Note that new logs will be opened as necessary (e.g. upon receipt of a
- * message, if the conversation has logging enabled. To disable logging for
- * the remainder of the conversation, use purple_conversation_set_logging().
- */
-void purple_conversation_close_logs(PurpleConversation *conv);
-
-/**
  * purple_conversation_write_message:
  * @conv: The conversation.
  * @msg:  The message to write.
diff --git a/libpurple/purpleconversation.c b/libpurple/purpleconversation.c
--- a/libpurple/purpleconversation.c
+++ b/libpurple/purpleconversation.c
@@ -26,6 +26,7 @@
 
 #include "buddylist.h"
 #include "cmds.h"
+#include "conversations.h"
 #include "debug.h"
 #include "notify.h"
 #include "prefs.h"
@@ -46,10 +47,6 @@
 	char *name;                       /* The name of the conversation.     */
 	char *title;                      /* The window title.                 */
 
-	gboolean logging;                 /* The status of logging.            */
-
-	GList *logs;                      /* This conversation's logs          */
-
 	PurpleConversationUiOps *ui_ops;  /* UI-specific operations.           */
 
 	PurpleConnectionFlags features;   /* The supported features            */
@@ -61,7 +58,6 @@
 	PROP_ACCOUNT,
 	PROP_NAME,
 	PROP_TITLE,
-	PROP_LOGGING,
 	PROP_FEATURES,
 	N_PROPERTIES
 };
@@ -235,9 +231,6 @@
 			g_free(priv->title);
 			priv->title = g_value_dup_string(value);
 			break;
-		case PROP_LOGGING:
-			purple_conversation_set_logging(conv, g_value_get_boolean(value));
-			break;
 		case PROP_FEATURES:
 			purple_conversation_set_features(conv, g_value_get_flags(value));
 			break;
@@ -263,9 +256,6 @@
 		case PROP_TITLE:
 			g_value_set_string(value, purple_conversation_get_title(conv));
 			break;
-		case PROP_LOGGING:
-			g_value_set_boolean(value, purple_conversation_is_logging(conv));
-			break;
 		case PROP_FEATURES:
 			g_value_set_flags(value, purple_conversation_get_features(conv));
 			break;
@@ -345,7 +335,6 @@
 	purple_signal_emit(purple_conversations_get_handle(),
 	                   "deleting-conversation", conv);
 
-	purple_conversation_close_logs(conv);
 	purple_conversation_clear_message_history(conv);
 
 	if(ops != NULL && ops->destroy_conversation != NULL) {
@@ -388,12 +377,6 @@
 		NULL,
 		G_PARAM_READWRITE | G_PARAM_CONSTRUCT | G_PARAM_STATIC_STRINGS);
 
-	properties[PROP_LOGGING] = g_param_spec_boolean(
-		"logging", "Logging status",
-		"Whether logging is enabled or not.",
-		FALSE,
-		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
-
 	properties[PROP_FEATURES] = g_param_spec_flags(
 		"features", "Connection features",
 		"The connection features of the conversation.",
@@ -606,58 +589,6 @@
 }
 
 void
-purple_conversation_set_logging(PurpleConversation *conv, gboolean log) {
-	PurpleConversationPrivate *priv = NULL;
-
-	g_return_if_fail(PURPLE_IS_CONVERSATION(conv));
-	priv = purple_conversation_get_instance_private(conv);
-
-	if(priv->logging != log) {
-		priv->logging = log;
-		if(log && priv->logs == NULL) {
-			GDateTime *dt;
-			PurpleLog *log;
-
-			dt = g_date_time_new_now_local();
-			log = purple_log_new(PURPLE_IS_CHAT_CONVERSATION(conv)
-			                     ? PURPLE_LOG_CHAT
-			                     : PURPLE_LOG_IM,
-			                     priv->name, priv->account, conv,
-			                     dt);
-			g_date_time_unref(dt);
-
-			priv->logs = g_list_append(NULL, log);
-		}
-
-		g_object_notify_by_pspec(G_OBJECT(conv), properties[PROP_LOGGING]);
-
-		purple_conversation_update(conv, PURPLE_CONVERSATION_UPDATE_LOGGING);
-	}
-}
-
-gboolean
-purple_conversation_is_logging(PurpleConversation *conv) {
-	PurpleConversationPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_CONVERSATION(conv), FALSE);
-
-	priv = purple_conversation_get_instance_private(conv);
-
-	return priv->logging;
-}
-
-void
-purple_conversation_close_logs(PurpleConversation *conv) {
-	PurpleConversationPrivate *priv = NULL;
-
-	g_return_if_fail(PURPLE_IS_CONVERSATION(conv));
-
-	priv = purple_conversation_get_instance_private(conv);
-	g_list_free_full(priv->logs, (GDestroyNotify)purple_log_free);
-	priv->logs = NULL;
-}
-
-void
 _purple_conversation_write_common(PurpleConversation *conv,
                                   PurpleMessage *pmsg)
 {
@@ -746,11 +677,8 @@
 		}
 	}
 
-	if(!(purple_message_get_flags(pmsg) & PURPLE_MESSAGE_NO_LOG) &&
-	   purple_conversation_is_logging(conv))
+	if(!(purple_message_get_flags(pmsg) & PURPLE_MESSAGE_NO_LOG))
 	{
-		GList *log;
-		GDateTime *dt;
 		GError *error = NULL;
 		PurpleHistoryManager *manager = NULL;
 
@@ -763,20 +691,6 @@
 
 			g_clear_error(&error);
 		}
-
-
-		/* The following should be deleted when the history api is stable. */
-		dt = g_date_time_ref(purple_message_get_timestamp(pmsg));
-		log = priv->logs;
-		while(log != NULL) {
-			purple_log_write((PurpleLog *)log->data,
-			                 purple_message_get_flags(pmsg),
-			                 purple_message_get_author_alias(pmsg),
-			                 dt,
-			                 purple_message_get_contents(pmsg));
-			log = log->next;
-		}
-		g_date_time_unref(dt);
 	}
 
 	if(ops) {
diff --git a/libpurple/purpleimconversation.c b/libpurple/purpleimconversation.c
--- a/libpurple/purpleimconversation.c
+++ b/libpurple/purpleimconversation.c
@@ -22,6 +22,7 @@
 #include <libpurple/purpleimconversation.h>
 
 #include <libpurple/debug.h>
+#include <libpurple/conversations.h>
 #include <libpurple/purpleconversationmanager.h>
 #include <libpurple/purpleenums.h>
 #include <libpurple/purpleprivate.h>
@@ -178,10 +179,6 @@
 		purple_buddy_icon_unref(icon);
 	}
 
-	if(purple_prefs_get_bool("/purple/logging/log_ims")) {
-		purple_conversation_set_logging(PURPLE_CONVERSATION(im), TRUE);
-	}
-
 	g_object_unref(account);
 	g_free(name);
 }
diff --git a/libpurple/savedstatuses.c b/libpurple/savedstatuses.c
--- a/libpurple/savedstatuses.c
+++ b/libpurple/savedstatuses.c
@@ -23,6 +23,7 @@
 
 #include "internal.h"
 
+#include "accounts.h"
 #include "debug.h"
 #include "idle.h"
 #include "notify.h"
diff --git a/libpurple/server.c b/libpurple/server.c
--- a/libpurple/server.c
+++ b/libpurple/server.c
@@ -28,7 +28,6 @@
 #include "internal.h"
 #include "buddylist.h"
 #include "debug.h"
-#include "log.h"
 #include "notify.h"
 #include "prefs.h"
 #include "protocol.h"
diff --git a/libpurple/status.c b/libpurple/status.c
--- a/libpurple/status.c
+++ b/libpurple/status.c
@@ -503,58 +503,6 @@
 * PurpleStatus API
 **************************************************************************/
 static void
-notify_buddy_status_update(PurpleBuddy *buddy, PurplePresence *presence,
-		PurpleStatus *old_status, PurpleStatus *new_status)
-{
-	if (purple_prefs_get_bool("/purple/logging/log_system"))
-	{
-		GDateTime *current_time = g_date_time_new_now_utc();
-		const char *buddy_alias = purple_buddy_get_alias(buddy);
-		char *tmp, *logtmp;
-		PurpleLog *log;
-
-		if (old_status != NULL)
-		{
-			tmp = g_strdup_printf(_("%s (%s) changed status from %s to %s"), buddy_alias,
-			                      purple_buddy_get_name(buddy),
-			                      purple_status_get_name(old_status),
-			                      purple_status_get_name(new_status));
-			logtmp = g_markup_escape_text(tmp, -1);
-		}
-		else
-		{
-			/* old_status == NULL when an independent status is toggled. */
-
-			if (purple_status_is_active(new_status))
-			{
-				tmp = g_strdup_printf(_("%s (%s) is now %s"), buddy_alias,
-				                      purple_buddy_get_name(buddy),
-				                      purple_status_get_name(new_status));
-				logtmp = g_markup_escape_text(tmp, -1);
-			}
-			else
-			{
-				tmp = g_strdup_printf(_("%s (%s) is no longer %s"), buddy_alias,
-				                      purple_buddy_get_name(buddy),
-				                      purple_status_get_name(new_status));
-				logtmp = g_markup_escape_text(tmp, -1);
-			}
-		}
-
-		log = purple_account_get_log(purple_buddy_get_account(buddy), FALSE);
-		if (log != NULL)
-		{
-			purple_log_write(log, PURPLE_MESSAGE_SYSTEM, buddy_alias,
-			               current_time, logtmp);
-		}
-
-		g_date_time_unref(current_time);
-		g_free(tmp);
-		g_free(logtmp);
-	}
-}
-
-static void
 notify_status_update(PurplePresence *presence, PurpleStatus *old_status,
 					 PurpleStatus *new_status)
 {
@@ -572,12 +520,6 @@
 			ops->status_changed(account, new_status);
 		}
 	}
-	else if (PURPLE_IS_BUDDY_PRESENCE(presence))
-	{
-		notify_buddy_status_update(purple_buddy_presence_get_buddy(
-				PURPLE_BUDDY_PRESENCE(presence)), presence, old_status,
-				new_status);
-	}
 }
 
 static void
diff --git a/libpurple/xfer.c b/libpurple/xfer.c
--- a/libpurple/xfer.c
+++ b/libpurple/xfer.c
@@ -38,6 +38,7 @@
 #include "purpleconversationmanager.h"
 #include "purpleenums.h"
 #include "request.h"
+#include "server.h"
 #include "util.h"
 #include "xfer.h"
 
